// #
// # Editor    : Phoebe from DFRobot
// # Data      : 19.07.2012
// # E-Mail    : phoebe.wang@dfrobot.com

// # Product name: IR scanner Kit
// # Product SKU:  KIT0019
// # Version :     0.1

// # Description:
// # The Sketch for scanning 120 degree area 10-80cm detecting range

// # Steps:
// #       1.Connect the IR sensor wire to the analog pin 0
// #       2.Connect the Servo wire to the digital pin 9

#include <math.h>                              
#include <Servo.h>                                //Include Servo library
Servo irservo;                                    // create servo object to control a servo 

void setup()
{
  irservo.attach(9);                              // attaches the servo on pin 9 to the servo object 
  Serial.begin(19200);                            // Init the Serial communication  
}

int pos=0;                                        // variable to store the servo position 
unsigned long time;                               // create a time variable
boolean up= true;                                 // create a boolean variable 
unsigned long irTimer ;                           // timer for managing the sensor reading flash rate

void loop()
{
  if(millis()-time>=20){                          // interval 0.02 seconds
    time = millis();                              // get the current time of programme
    if(up){                                       // judge the condition
      if(pos>=0 && pos<=179){                   
        pos=pos+1;                                // in steps of 1 degree
        irservo.write(pos);                       // tell servo to go to position in variable 'pos'
      }
      if(pos>179)  up= false;                     // assign the variable again
    }

    else {                                       
      if(pos>=1 && pos<=180){    
        pos=pos-1;
        irservo.write(pos);
      }
      if(pos<1)  up=true;
    }
  }

  if(millis() - irTimer > 20){
    irTimer = millis();
    float val=analogRead(0);                      // Read ir distance sensor data
    float distance=6787.0 /(val - 3.0) - 4.0;     // Convert to the distance - cm
    
    Serial.print(pos);                           // print current servo angle
    Serial.print(" ");
    Serial.println(distance);                    // print distance
  }


}








